<template>
  <q-layout view="lHh Lpr lFf">
    <q-header flat class="bg-white text-black" height-hint="100">
      <q-toolbar class="portal-toolbar-height">
        <q-avatar>
          <img alt="Vigan City Logo" src="~assets/vigan_logo.png" />
        </q-avatar>
        <q-toolbar-title>
          <div class="text">
            <div class="text-title">VIGAN CITY</div>
            <div class="text-subtitle">Job Matching Portal</div>
          </div>
        </q-toolbar-title>

        <div class="navigation-tab q-mx-xl">
          <q-tabs inline-label align="justify">
            <template
              v-for="(navigation, key) in PORTAL_EMPLOYER_MENU_OPTIONS"
              :key="key"
            >
              <q-route-tab
                no-caps
                :to="navigation.link"
                :label="navigation.label"
                :disable="
                  (navigation.label === 'Messages' ||
                    navigation.label === 'My Jobs') &&
                  EMAIL_VERIFIED_AT === null
                "
              >
                <q-tooltip
                  v-if="
                    (navigation.label === 'Messages' ||
                      navigation.label === 'My Jobs') &&
                    EMAIL_VERIFIED_AT === null
                  "
                  class="bg-grey-8 title-10"
                  :offset="[10, 10]"
                >
                  Pending account approval. Access is denied.
                </q-tooltip>

                <q-badge
                  v-show="notificationCount(navigation.label)"
                  color="negative"
                  rounded
                  class="q-ml-sm"
                >
                  <span class="notification q-mx-auto">
                    {{ notificationCount(navigation.label) }}
                  </span>
                </q-badge>
              </q-route-tab>
            </template>
          </q-tabs>
        </div>

        <q-space />
        <!-- <notifications-menu></notifications-menu> -->
        <!-- <messages-menu></messages-menu> -->
        <user-account-menu></user-account-menu>
      </q-toolbar>
    </q-header>

    <q-page-container>
      <router-view />
    </q-page-container>
  </q-layout>
</template>

<script>
import { defineComponent, computed, ref } from "vue";
// import NotificationsMenu from "../portals/partials/NotificationsMenu.vue";
// import MessagesMenu from "../portals/partials/MessagesMenu.vue";
import UserAccountMenu from "../portals/partials/UserAccountMenu.vue";
import { PORTAL_EMPLOYER_MENU_OPTIONS } from "../portals/constants";
import { useEmployer } from "../portals/store/employer";
import { useRoom } from "src/modules/messages-employer/store/room";
import { useApplication } from "src/modules/messages-employer/store/application";
import { usePusher } from "../portals/store/pusher";
import { useUser } from "src/layouts/portals/store/user";
import { LocalStorage } from "quasar";
import { pusher, pusherConfig } from "boot/pusher";
import CryptoJS from "crypto-js";
import { onMounted, onUnmounted } from "vue";
import { useReference } from "src/modules/auth/store/reference";

export default defineComponent({
  components: {
    // NotificationsMenu,
    // MessagesMenu,
    UserAccountMenu,
  },
  name: "EmployerPortalLayout",

  setup() {
    const roomStore = useRoom();
    const { getRoomIDs, getRooms, updateRooms, resetRooms } = roomStore;

    const pusherStore = usePusher();
    const { addPusherChannel, clearPusherChannel } = pusherStore;

    const employerStore = useEmployer();
    const { getNotificationCount } = employerStore;

    const applicationStore = useApplication();
    const userStore = useUser();
    const referenceStore = useReference();

    const userID = LocalStorage.getItem("auth").id;

    const EMAIL_VERIFIED_AT = LocalStorage.getItem("auth").email_verified_at;

    onMounted(() => {
      fetchData();
      // setTimeout(() => {
      //   window.location.reload();
      // }, 1000);
    });

    onUnmounted(() => {
      pusherStore.channels.forEach((channelName) => {
        // console.log("unsubscribe: ", channelName);
        let data = {
          channel: channelName,
        };
        pusher.send_event("pusher:unsubscribe", data);
      });
      clearPusherChannel();
      resetRooms();

      roomStore.$dispose();
      pusherStore.$dispose();
      employerStore.$dispose();
      applicationStore.$dispose();
      userStore.$dispose();
      referenceStore.$dispose();
    });

    const fetchData = async () => {
      subscribeToPusherChannel("private-employer-" + userID);
      subscribeToPusherChannel("private-user-" + userID);
      await getRoomIDs();
      await getRooms();
      await getNotificationCount();
      subscribeToRoomChannel();
      pusherBind();
    };

    const subscribeToRoomChannel = () => {
      roomStore.roomIDs.forEach((room) => {
        const channelName = "private-room-" + room.id;
        subscribeToPusherChannel(channelName);
      });
    };

    const subscribeToPusherChannel = (channelName) => {
      if (!pusherStore.channels.includes(channelName)) {
        if (channelName.includes("private-")) {
          let value = pusher.connection.socket_id + ":" + channelName;

          const signature = CryptoJS.HmacSHA256(
            value,
            pusherConfig.APP_SECRET
          ).toString(CryptoJS.enc.Hex);

          let data = {
            auth: pusherConfig.APP_KEY + ":" + signature,
            channel: channelName,
          };

          pusher.send_event("pusher:subscribe", data);
        } else {
          pusher.subscribe(channelName);
        }
        addPusherChannel(channelName);
      }
    };

    const pusherBind = () => {
      pusher.connection.bind("message", (msg) => {
        // console.log("pusherBind: ", msg);
        if (msg.event == "room") {
          console.log("event: room");
          console.log("message: ", msg);
          if (msg.data.userId == userID) {
            updateRooms(msg.data.data);
            let room = roomStore.room.find(
              (item) => item.id === msg.data.data.id
            );
            console.log("room: ", room);
            if (!room) {
              const channelName = "private-room-" + msg.data.data.id;
              subscribeToPusherChannel(channelName);
            }
          }
        } else if (
          msg.event == "pending-job-post" ||
          msg.event == "active-job-post"
        ) {
          getNotificationCount();
        }
      });
    };

    const notificationCount = (title) => {
      if (title == "Messages") {
        const unReadNotifications = roomStore.rooms.filter((item) =>
          isUnread(item.latest_message)
        );
        return unReadNotifications.length;
      } else if (title == "My Jobs") {
        if (employerStore.notificationCount) {
          return (
            Number(employerStore.notificationCount.all) -
            Number(employerStore.notificationCount.rejected)
          );
        }
      }
      return 0;
    };

    // const notificationCount = computed(() => {
    //   const unReadNotifications = roomStore.rooms.filter((item) =>
    //     isUnread(item.latest_message)
    //   );
    //   return unReadNotifications.length;
    // });

    const isUnread = (message) => {
      if (message == null) return false;
      if (message.user_id != userID) {
        return message.read_at == null;
      }
      return false;
    };

    return {
      roomStore,
      pusherStore,
      notificationCount,
      userID,
      PORTAL_EMPLOYER_MENU_OPTIONS,
      EMAIL_VERIFIED_AT,
    };
  },
});
</script>

<style lang="scss" scoped>
.q-layout {
  background-color: #f1f1f1;
}
.q-header {
  -webkit-box-shadow: 0 10px 20px black;
  -moz-box-shadow: 0 10px 20px black;
  box-shadow: 0 -10px 20px black;
}

.q-avatar,
img {
  height: 50px !important;
  width: 50px !important;
}
.portal {
  &-toolbar {
    &-height {
      height: 100px;
    }
  }
}

.text {
  line-height: 20px;
  width: 105px;
  &-title {
    font-weight: 800;
    color: #4c1cc0;
    font-size: 15px;
  }
  &-subtitle {
    font-weight: 600;
    color: $dark;
    font-size: 11px;
  }
}
div.q-badge {
  width: 22px;
  height: 22px;
  border-radius: 50px !important;
  display: flex;
  justify-content: center;
  align-items: center;
}
</style>
